% ICA over Galois Fields immune-inspired algorithm - cobICA %
% simulation script %
% Daniel Guerreiro e Silva - 12/01/2015%



clc;
clear all;
close all;

q = 2;              %size of GF(q^m)
m = 1;
K = 4;              %number of sources;
Nobs = 256;         %number of observations;
 

if (m>1)
    field = gftuple([-1:q^m-2]',m,q); % Construct list of elements.
else
    field = [];
end

thre = 0.2;         %non-uniformity threshold

%struct with some parameters of cobICA
pm = struct('nCLmax',10,'nCLmin',2,'sigmas',.1,'C0',1,'maxEpoch',300);
RandStream.setGlobalStream(RandStream('mt19937ar','seed',sum(clock)));

% generate a random probabilities vector
[probs,S] = geravetorsinais(q,m,K,thre,Nobs);

%random generation of mixing matrix
A = geramatrizmistura(q,m,field,K);
%mixtures
X = produtomatrizGF(A,S,q,m,field);        
        
        
%% %%%%%%%%%%%%%%%%%%%%cobICA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%

funcao_fitness = @(ab)fitness_sum_mlh(ab,X,q,m,field);

[W,bestCost,meanCost,ABfinal,fitfinal,Cfinal,rstfit] = cobicaEF(K,q,m,field,pm,funcao_fitness);  
U = produtomatrizGF(W,A,q,m,field);
if(m>1)
    Z = (U>-1); %null element in GF(q^m) 
else
    Z = (U>0); 
end
hits = sum(sum(Z,2)==1);

disp(Z);
fprintf('%d hits for cobICA\n\n',hits);

fprintf('Mixing matrix:\n');
disp(A);

fprintf('Separating matrix:\n');
disp(W);